#/* Copyright 1998-2011 Research Foundation State University of New York */
#
#/* This file is part of QuB.                                            */
#
#/* QuB is free software; you can redistribute it and/or modify          */
#/* it under the terms of the GNU General Public License as published by */
#/* the Free Software Foundation, either version 3 of the License, or    */
#/* (at your option) any later version.                                  */
#
#/* QuB is distributed in the hope that it will be useful,               */
#/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
#/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
#/* GNU General Public License for more details.                         */
#
#/* You should have received a copy of the GNU General Public License,   */
#/* named LICENSE.txt, in the QuB program directory.  If not, see        */
#/* <http://www.gnu.org/licenses/>.                                      */

import QUB
from Buttons import AddTaskButton

def CheckList(props):
    try:
        lst = QUB.DataView.currData.lists.currList
        QUB.Report('Checking list for overlaps:')
        last = -1
        lastsel = (-1, -1)
        lasti = -1
        for i, sel in enumerate(lst):
            if sel[0] <= last:
                QUB.Report('sel %d %s overlaps sel %d %s' % (i+1, sel, lasti+1, lastsel))
            if sel[1] >= last:
                last = sel[1]
                lastsel = sel
                lasti = i
        QUB.Report('Done.')
    except:
        pass

AddTaskButton( 'Check List', # button text
               CheckList,   # function
               'CkList',       # short text for small buttons
               0,            # show settings dialog on left-click?
               0,            # show settings dialog on right-click?
               "Check selection list for overlapping selections",   # tool-tip
               "Check selection list for overlapping selections",   # description in "Edit Buttons"
               "", # caption for the settings dialog
               [],
               'Lists')

    